package com.ruoyi.ai.service.impl;

import java.util.List;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.ai.mapper.AiManagerMapper;
import com.ruoyi.ai.domain.AiManager;
import com.ruoyi.ai.service.IAiManagerService;

/**
 * AI管理Service业务层处理
 * 
 * @author shi
 * @date 2025-11-13
 */
@Service
public class AiManagerServiceImpl implements IAiManagerService {

    @Autowired
    private AiManagerMapper aiManagerMapper;

    /**
     * 查询AI管理
     * 
     * @param id AI管理主键
     * @return AI管理
     */
    @Override
    public AiManager selectAiManagerById(Long id) {
        return aiManagerMapper.selectById(id);
    }

    /**
     * 查询AI管理列表
     * 
     * @param aiManager AI管理
     * @return AI管理
     */
    @Override
    public List<AiManager> selectAiManagerList(AiManager aiManager) {
        LambdaQueryWrapper<AiManager> query = Wrappers.lambdaQuery(aiManager);
        query.eq(AiManager::getDelFlag, "0");
        List<AiManager> aiManagers = aiManagerMapper.selectList(query);
        return aiManagers;
    }

    /**
     * 分页查询AI管理列表
     *
     * @param aiManager AI管理
     * @return AI管理
     */
    @Override
    public IPage<AiManager> selectAiManagerPage(Page page, AiManager aiManager) {
        LambdaQueryWrapper<AiManager> query = Wrappers.lambdaQuery(aiManager);
        query.eq(AiManager::getDelFlag, "0");
        return aiManagerMapper.selectPage(page, query);
    }

    /**
     * 新增AI管理
     * 
     * @param aiManager AI管理
     * @return 结果
     */
    @Override
    public int insertAiManager(AiManager aiManager) {
        aiManager.setDelFlag("0");
        aiManager.setCreateBy(SecurityUtils.getUsername());
        aiManager.setCreateTime(DateUtils.getNowDate());
        return aiManagerMapper.insert(aiManager);
    }

    /**
     * 修改AI管理
     * 
     * @param aiManager AI管理
     * @return 结果
     */
    @Override
    public int updateAiManager(AiManager aiManager) {
        aiManager.setUpdateBy(SecurityUtils.getUsername());
        aiManager.setUpdateTime(DateUtils.getNowDate());
        return aiManagerMapper.updateById(aiManager);
    }

    /**
     * 批量删除AI管理
     * 
     * @param ids 需要删除的AI管理主键
     * @return 结果
     */
    @Override
    public int deleteAiManagerByIds(Long[] ids)
    {
        return aiManagerMapper.deleteAiManagerByIds(ids);
    }

    /**
     * 删除AI管理信息
     * 
     * @param id AI管理主键
     * @return 结果
     */
    @Override
    public int deleteAiManagerById(Long id)
    {
        return aiManagerMapper.deleteAiManagerById(id);
    }

    @Override
    public int updateAiStatus(AiManager aiManager) {
        return aiManagerMapper.updateById(aiManager);
    }

    @Override
    public AiManager selectAiManagerByType(String aiType) {
        QueryWrapper<AiManager> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("type", aiType);
        return aiManagerMapper.selectOne(queryWrapper);
    }
}
